/*********************************************/
/* NLM Magic.c                               */
/*                                           */
/* Realise par Couery Tanguy et Bretin David */
/* Pour Le Projet NOVELL                     */
/* BRETIN David, COUERY Tanguy GUILHEM Eric  */
/* Mars 1996 V1.0                            */
/*                                           */
/* Communication TLI et modification Bindery */
/* Base sur FILETX.C de NOVELL               */
/*********************************************/

/**  ANSI  **/
#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <conio.h>
#include <process.h>
#include <sys/types.h>
#include <fcntl.h>

/** NetWare **/
#include <niterror.h>
#include <tiuser.h>
#include <nwbindry.h>
#include <nwdir.h>


/** Define **/
#define TLI_PORT 31 /** port de communication **/
#define BUF_SIZE 65528 /** taille du buffeur **/
#define PASSWORD "TOTO"

/** Variable Global **/
int ccode;
int fh;
struct  t_bind tbind;
struct  t_call tcall;
IPX_ADDR        spx_addr;
SPX_OPTS        spx_options;
int nb_child=0;
int finNLM=0;

int CompteurDump;
char *Dump;



/**********************************/
/* Fonctions de lecture dans Dump */
/**********************************/
long LitLong(void)
{
	long Ret;
	memcpy(&Ret, &Dump[CompteurDump], 4);
	CompteurDump = CompteurDump + 4;
	return Ret;
}

int LitWord(void)
{
	int Ret;
	memcpy(&Ret, &Dump[CompteurDump], 2);
	CompteurDump = CompteurDump + 2;
	return Ret;
}

char LitByte(void)
{
	char Ret;
	memcpy(&Ret, &Dump[CompteurDump], 1);
	CompteurDump++;
	return Ret;
}


char *LitChaine(void)
{
	char *Ret;
	Ret = &Dump[CompteurDump];
	while(Dump[CompteurDump] != 0) CompteurDump++;
	CompteurDump++;
	return Ret;
}

char *LitPpteValue(void)
{
	char *Ret;
	Ret = &Dump[CompteurDump];
	CompteurDump = CompteurDump + 128;
	return Ret;
}


/**********************************/
/* Fonctions d'ecriture dans Dump */
/**********************************/
void EcritLong(long LongInt)
{
	memcpy(&Dump[CompteurDump], &LongInt, 4);
	CompteurDump = CompteurDump + 4;
}

void EcritWord(int Word)
{
	memcpy(&Dump[CompteurDump], &Word, 2);
	CompteurDump = CompteurDump + 2;
}

void EcritByte(char Byte)
{
	Dump[CompteurDump] = Byte;
	CompteurDump++;
}

void EcritChaine(char *Chaine)
{

	int Compteur;
	for(Compteur=0; Chaine[Compteur] != 0; Compteur++);
	memcpy(&Dump[CompteurDump], Chaine, Compteur+1);
	CompteurDump = CompteurDump + Compteur + 1;
}

void EcritPpteValue(char *Buffer)
{
	memcpy(&Dump[CompteurDump], Buffer, 128);
	CompteurDump = CompteurDump + 128;
}

/************************/
/* Creation d'un object */
/************************/
void CreateObject()
{
	char *ObjName;
	WORD ObjType, Ret;
	char ObjFlags, ObjSecu;

	printf("\nCreation d'object");
	ObjName = LitChaine();
	ObjType = LitWord();
	ObjFlags = LitByte();
	ObjSecu = LitByte();
	;printf("\nObjName = %s", ObjName);
	;printf("\nObjType = %d", ObjType);
	;printf("\nObjFlags = %d", ObjFlags);
	;printf("\nObjSecu = %d", ObjSecu);

	Ret = CreateBinderyObject(ObjName, ObjType, ObjFlags, ObjSecu);
	;printf("\nRet = %d", Ret);
	CompteurDump = 1;
	EcritWord(Ret);
}

/**********************************/
/* Scan les objects de la bindery */
/**********************************/
void ScanObject()
{
	char *SearchName, *ObjName;
	WORD SearchType, ObjType, Ret;
	long ObjID;
	char HasPpteFlag, ObjFlag, ObjSecu;

	printf("\nScan object");
	SearchName = LitChaine();
	SearchType = LitWord();
	ObjID = LitLong();
	// printf("\nSearchName = %s", SearchName);
	// printf("\nSearchType = %d", SearchType);
	// printf("\nObjID = %#x", ObjID);

	ObjName = malloc(48);
	Ret = ScanBinderyObject(SearchName, SearchType, &ObjID, ObjName, &ObjType, &HasPpteFlag, &ObjFlag, &ObjSecu);
	;printf("\nRet = %d", Ret);
	CompteurDump = 1;
	EcritWord(Ret);
	if (Ret == 0) 
	{
		;printf("\nObjID = %#x", ObjID);
		;printf("\nObjName = %s", ObjName);
		;printf("\nObjType = %d", ObjType);
		;printf("\nHasPpteFlag = %d", HasPpteFlag);
		;printf("\nObjFlag = %d", ObjFlag);
		;printf("\nObjSecu = %d", ObjSecu);
		EcritLong(ObjID);
		EcritChaine(ObjName);
		EcritWord(ObjType);
		EcritByte(HasPpteFlag);
		EcritByte(ObjFlag);
		EcritByte(ObjSecu);
	}
	free(ObjName);
}

/**********************************/
/* Efface un object de la bindery */
/**********************************/
void DeleteObject()
{
	char *ObjName;
	WORD ObjType, Ret;
	
	printf("\nDelete object");
	ObjName = LitChaine();
	ObjType = LitWord();
	;printf("\nObjName = %s", ObjName);
	;printf("\nObjType = %d", ObjType);

	Ret = DeleteBinderyObject(ObjName, ObjType);
	;printf("\nRet = %d", Ret);
	CompteurDump = 1;
	EcritWord(Ret);
}

/*****************************************************/
/* Verifie le mot de passe d'un object de la bindery */
/*****************************************************/
void VerifyObjPassword()
{
	char *ObjName, *Password;
	WORD ObjType, Ret;

	printf("\nVerify Object Password");
	ObjName = LitChaine();
	ObjType = LitWord();
	Password = LitChaine();
	;printf("\nObjName = %s", ObjName);
	;printf("\nObjType = %d", ObjType);
	;printf("\nPassword = %s", Password);

	Ret = VerifyBinderyObjectPassword(ObjName, ObjType, Password);
	;printf("\nRet = %d", Ret);
	CompteurDump = 1;
	EcritWord(Ret);
}

/****************************************************/
/* Change le mot de passe d'un object de la bindery */
/****************************************************/
void ChangeObjPassword()
{
	char *ObjName, *OldPassword, *NewPassword;
	WORD ObjType, Ret;

	printf("\nChange Object Password");
	ObjName = LitChaine();
	ObjType = LitWord();
	OldPassword = LitChaine();
	NewPassword = LitChaine();
	;printf("\nObjName = %s", ObjName);
	;printf("\nObjType = %d", ObjType);
	;printf("\nOld Password = %s", OldPassword);
	;printf("\nNew Password = %s", NewPassword);
	
	Ret = ChangeBinderyObjectPassword(ObjName, ObjType, OldPassword, NewPassword);
	;printf("\nRet = %d", Ret);
	CompteurDump = 1;
	EcritWord(Ret);
}

/*************************************************/
/* Scan les proprietes d'un object de la bindery */
/*************************************************/
void ScanPpte()
{        
	char *SearchPpteName, *PpteName, *ObjName;
	WORD ObjType, Ret;
	long SequenceNumber;
	char PpteFlag, PpteSecu, PpteHasValue, MorePpte;
	
	printf("\nScan Ppte");
	ObjName = LitChaine();
	ObjType = LitWord();
	SearchPpteName = LitChaine();
	SequenceNumber = LitLong();
	;printf("\nObjName = %s", ObjName);
	;printf("\nObjType = %d", ObjType);
	;printf("\nSearchPpteName = %s", SearchPpteName);
	;printf("\nSequenceNumber = %d", SequenceNumber);

	PpteName = malloc(16);
	Ret = ScanProperty(ObjName, ObjType, SearchPpteName, &SequenceNumber, PpteName, &PpteFlag, &PpteSecu, &PpteHasValue, &MorePpte);
	;printf("\nRet = %d", Ret);
	CompteurDump = 1;
	EcritWord(Ret);
	if (Ret == 0) 
	{
		;printf("\nSequenceNumber = %d", SequenceNumber);
		;printf("\nPpteName = %s", PpteName);
		;printf("\nPpteFlag = %d", PpteFlag);
		;printf("\nPpteSecu = %d", PpteSecu);
		;printf("\nPpteHasValue = %d", PpteHasValue);
		;printf("\nMorePpte = %d", MorePpte);
		EcritLong(SequenceNumber);
		EcritChaine(PpteName);
		EcritByte(PpteFlag);
		EcritByte(PpteSecu);
		EcritByte(PpteHasValue);
		EcritByte(MorePpte);
	}
	free(PpteName);
}

/***************************************************/
/* Cree une propriete dans un object de la bindery */
/***************************************************/
void CreatePpte()
{
	char *ObjName, *PpteName;
	WORD ObjType, Ret;
	char PpteFlag, PpteSecu;

	printf("\nCreate Ppte");
	ObjName = LitChaine();
	ObjType = LitWord();
	PpteName = LitChaine();
	PpteFlag = LitByte();
	PpteSecu = LitByte();
	;printf("\nObjName = %s", ObjName);
	;printf("\nObjType = %d", ObjType);
	;printf("\nPpteName = %s", PpteName);
	;printf("\nPpteFlag = %d", PpteFlag);
	;printf("\nPpteSecu = %d", PpteSecu);
	
	Ret = CreateProperty(ObjName, ObjType, PpteName, PpteFlag, PpteSecu);
	;printf("\nRet = %d", Ret);
	CompteurDump = 1;
	EcritWord(Ret);
}
			
/***********************************/
/* Renomme un object de la bindery */                        
/***********************************/
void RenameObj()
{
	char *ObjName, *NewObjName;
	WORD ObjType, Ret;
	
	printf("\nRename Object");
	ObjName = LitChaine();
	NewObjName = LitChaine();
	ObjType = LitWord();
	;printf("\nObjName = %s", ObjName);
	;printf("\nNewObjName = %s", NewObjName);
	;printf("\nObjType = %d", ObjType);
	
	Ret = RenameBinderyObject(ObjName, NewObjName, ObjType);
	;printf("\nRet = %d", Ret);
	CompteurDump = 1;
	EcritWord(Ret);
}

/************************************************/
/* Change la securite d'un object de la bindery */
/************************************************/
void ChangeObjSecu()
{
	char *ObjName;
	WORD ObjType, Ret;
	char NewObjSecu;
	
	printf("\nChange Obj Secu");
	ObjName = LitChaine();
	ObjType = LitWord();
	NewObjSecu = LitByte();
	;printf("\nObjName = %s", ObjName);
	;printf("\nObjType = %d", ObjType);
	;printf("\nNewObjSecu = %d", NewObjSecu);
	
	Ret = ChangeBinderyObjectSecurity(ObjName, ObjType, NewObjSecu);
	;printf("\nRet = %d", Ret);
	CompteurDump = 1;
	EcritWord(Ret);
}

/***********************************************/
/* Renvoie le nom d'un object d'apres si numID */
/***********************************************/
void GetObjName()
{
	char *ObjName;
	WORD ObjType, Ret;
	long ObjID;
	
	printf("\nGet Object Name");
	ObjID = LitLong();
	;printf("\nObjID = %#x", ObjID);
	
	ObjName = malloc(48);
	Ret = GetBinderyObjectName(ObjID, ObjName, &ObjType);
	;printf("\nRet = %d", Ret);
	CompteurDump = 1;
	EcritWord(Ret);
	if (Ret == 0)
	{
		;printf("\nObjName = %s", ObjName);
		;printf("\nObjType = %d", ObjType);
		EcritChaine(ObjName);
		EcritWord(ObjType);
	}
	free(ObjName);
}

/*****************************************************/
/* Test si un object est dans une ppte (de type SET) */                        
/*****************************************************/
void IsObjInSet()
{
	char *ObjName, *PpteName, *MemberName;
	WORD ObjType, MemberType, Ret;
	
	printf("\nIsObjInSet");
	ObjName = LitChaine();
	ObjType = LitWord();
	PpteName = LitChaine();
	MemberName = LitChaine();
	MemberType = LitWord();
	;printf("\nObjName = %s", ObjName);
	;printf("\nObjType = %d", ObjType);
	;printf("\nPpteName = %s", PpteName);
	;printf("\nMemberName = %s", MemberName);
	;printf("MemberName = %d", MemberType);

	Ret = IsBinderyObjectInSet(ObjName, ObjType, PpteName, MemberName, MemberType);
	;printf("\nRet = %d", Ret);
	CompteurDump = 1;
	EcritWord(Ret);
}

/*********************************************/
/* Enleve un object d'une ppte (de type SET) */
/*********************************************/
void DeleteObjFromSet()
{
	char *ObjName, *PpteName, *MemberName;
	WORD ObjType, MemberType, Ret;

	printf("\nDeleteObjFromSet");
	ObjName = LitChaine();
	ObjType = LitWord();
	PpteName = LitChaine();
	MemberName = LitChaine();
	MemberType = LitWord();
	;printf("\nObjName = %s", ObjName);
	;printf("\nObjType = %d", ObjType);
	;printf("\nPpteName = %s", PpteName);
	;printf("\nMemberName = %s", MemberName);
	;printf("MemberName = %d", MemberType);

	Ret = DeleteBinderyObjectFromSet(ObjName, ObjType, PpteName, MemberName, MemberType);
	;printf("\nRet = %d", Ret);
	CompteurDump = 1;
	EcritWord(Ret);
}

/*********************************************/
/* Ajoute un obj dans une ppte (de type SET) */
/*********************************************/
void AddObjToSet()
{
	char *ObjName, *PpteName, *MemberName;
	WORD ObjType, MemberType, Ret;
	
	printf("\nAddObjToSet");
	ObjName = LitChaine();
	ObjType = LitWord();
	PpteName = LitChaine();
	MemberName = LitChaine();
	MemberType = LitWord();
	;printf("\nObjName = %s", ObjName);
	;printf("\nObjType = %d", ObjType);
	;printf("\nPpteName = %s", PpteName);
	;printf("\nMemberName = %s", MemberName);
	;printf("MemberName = %d", MemberType);

	Ret = AddBinderyObjectToSet(ObjName, ObjType, PpteName, MemberName, MemberType);
	;printf("\nRet = %d", Ret);
	CompteurDump = 1;
	EcritWord(Ret);
}

/*******************************************/
/* Detruit une ppte d'un obj de la bindery */
/*******************************************/
void DeletePpte()
{
	char *ObjName, *PpteName;
	WORD ObjType, Ret;
	
	printf("\nDeletePpte");
	ObjName = LitChaine();
	ObjType = LitWord();
	PpteName = LitChaine();
	;printf("\nObjName = %s", ObjName);
	;printf("\nObjType = %d", ObjType);
	;printf("\nPpteName = %s", PpteName);

	Ret = DeleteProperty(ObjName, ObjType, PpteName);
	;printf("\nRet = %d", Ret);
	CompteurDump = 1;
	EcritWord(Ret);
}

/*************************************/
/* Renvoie la valeur d'une proprit */
/*************************************/
void ReadPpteValue()
{
	char *ObjName, *PpteName, *PpteValue;
	WORD ObjType, Ret;
	char MoreSeg, PpteFlag, SegNumber;

	printf("\nReadPpteValue");
	ObjName = LitChaine();
	ObjType = LitWord();
	PpteName = LitChaine();
	SegNumber = LitByte();
	;printf("\nObjName = %s", ObjName);
	;printf("\nObjType = %d", ObjType);
	;printf("\nPpteName = %s", PpteName);
	;printf("\nSegNumber = %d", SegNumber);

	PpteValue = malloc(128);
	Ret = ReadPropertyValue(ObjName, ObjType, PpteName, SegNumber, PpteValue, &MoreSeg, &PpteFlag);
	;printf("\nRet = %d", Ret);
	CompteurDump = 1;
	EcritWord(Ret);
	if (Ret == 0) 
	{
		;printf("\nMoreSeg = %d", MoreSeg);
		;printf("\nPpteFlag = %d", PpteFlag);
		;printf("\nPpteValue = ...");
		EcritPpteValue(PpteValue);
		EcritByte(MoreSeg);
		EcritByte(PpteFlag);

	}
	free(PpteValue);
}

/****************************************/
/* Ecrit dans la valeur d'une propriete */
/****************************************/
void WritePpteValue()
{
	char *ObjName, *PpteName, *PpteValue;
	WORD ObjType, Ret;
	char MoreSeg, SegNumber;

	printf("\nWritePpteValue");
	ObjName = LitChaine();
	ObjType = LitWord();
	PpteName = LitChaine();
	SegNumber = LitByte();
	PpteValue = LitPpteValue();
	MoreSeg = LitByte();
	;printf("\nObjName = %s", ObjName);
	;printf("\nObjType = %d", ObjType);
	;printf("\nPpteName = %s", PpteName);
	;printf("\nSegNumber = %d", SegNumber);
	;printf("\nPpteValue = ...");
	;printf("\nMoreSeg = %d", MoreSeg);

	Ret = WritePropertyValue(ObjName, ObjType, PpteName, SegNumber, PpteValue, MoreSeg);
	;printf("\nRet = %d", Ret);
	CompteurDump = 1;
	EcritWord(Ret);
}

/****************************************************/
/* Scan les trustees path d'un object de la bindery */
/****************************************************/
void ScanTrust()
{
	long ObjID;
	BYTE VolNumber;
	WORD TrustMask, Ret;
	int SeqNumber;
	char *Path;

	printf("\nScan Trustee");
	ObjID = LitLong();
	VolNumber = LitByte();
	SeqNumber = LitWord();
	;printf("\nObjID = %#x", ObjID);
	;printf("\nVolNumber = %d", VolNumber);
	;printf("\nSeqNumber = %d", SeqNumber);
	    
	Path = malloc(320);
	Ret = ScanBinderyObjectTrusteePaths(ObjID, VolNumber, &SeqNumber, &TrustMask, Path);
	;printf("\nRet = %d", Ret);
	CompteurDump = 1;
	EcritWord(Ret);
	if (Ret == 0)
	{
		;printf("\nSeqNumber = %d", SeqNumber);
		;printf("\nTrustMask = %d", TrustMask);
		;printf("\nPath = %s", Path);
		EcritWord(SeqNumber);
		EcritWord(TrustMask);
		EcritChaine(Path);
	}           
	free(Path);
}

/**************************************/
/* Enleve un trustee path d'un object */
/**************************************/
void DeleteTrust()
{
	char *Path;
	long ObjID;
	WORD Ret;

	printf("\nDeleteTrustee");
	Path = LitChaine();
	ObjID = LitLong();
	;printf("\nPath = %s", Path);
	;printf("\nObjID = %#x", ObjID);

	Ret = DeleteTrustee(Path, ObjID);
	;printf("\nRet = %d", Ret);
	CompteurDump = 1;
	EcritWord(Ret);
}

/**************************************/
/* Ajoute un trustee path a un object */
/**************************************/
void Addtrust()
{
	char *Path;
	long ObjID;
	WORD Ret, TrustMask;

	printf("\nAddTrust");
	Path = LitChaine();
	ObjID = LitLong();
	TrustMask = LitWord();
	;printf("\nPath = %s", Path);
	;printf("\nObjID = %#x", ObjID);
	;printf("\nTrustMask = %d", TrustMask);

	Ret = AddTrustee(Path, ObjID, TrustMask);
	;printf("\nRet = %d", Ret);
	CompteurDump = 1;
	EcritWord(Ret);
}



/********************************************/
/* Procedure Magic (Traite les fonctions)   */
/* newfh: socket pour ecrir                 */
/* buf:   Buffer avec les donnes           */
/* len:   Nombre de caracteres dans buf     */
/********************************************/
void magic (int newfh,char* buf,int len)
{
	int NumFonction;
	char *WSPassword;
	
	CompteurDump = 0;
	Dump = buf;

	printf("\n\nSocket %d", newfh);
	WSPassword = LitChaine();
	if (strcmp(PASSWORD, WSPassword) != 0)
	{
		printf("\nMauvais password");
		Dump[0] = 1;
		CompteurDump = 1;
	}
	else
	{
		Dump[0] = 0;
		NumFonction = LitWord();
		switch(NumFonction)
		{
			case 1: printf("\nTest mot de passe NLM"); break;
			case 2: CreateObject(); break;
			case 3: ScanObject(); break;
			case 4: DeleteObject(); break;
			case 5: VerifyObjPassword(); break;
			case 6: ChangeObjPassword(); break;
			//case 7: printf("\n\nDisallow Obj Password (a faire)"); CompteurDump = 1; EcritWord(-1); break;
			case 8: ScanPpte(); break;
			case 9: CreatePpte(); break;
			case 10: RenameObj(); break;
			case 11: ChangeObjSecu(); break;
			case 12: GetObjName(); break;
			case 13: IsObjInSet(); break;
			case 14: DeleteObjFromSet(); break;
			case 15: AddObjToSet(); break;
			case 16: DeletePpte(); break;
			case 17: ReadPpteValue(); break;
			case 18: WritePpteValue(); break;
			case 19: ScanTrust(); break;
			case 20: DeleteTrust(); break;
			case 21: Addtrust(); break;
			default: printf("\n\nFonction inconnue"); CompteurDump = 1; EcritWord(-1);
		}

	}
	t_snd(newfh, Dump, CompteurDump, 0);
}


/********************************************/
/* Procedure pour quiter le NLM             */
/********************************************/
void TerminateNLM(void)
  {
  finNLM=1;
  if (fh!=-1)
     {
     t_unbind( fh );
     t_close( fh );
     }
  while (nb_child!=0)
     ThreadSwitch();
  delay (10);
  }

/********************************************/
/* Processus Fils                           */
/********************************************/
void ChildProcess(void *param)
  {
  int newfh; /* nouvelle socket */
  char *buf;
  int taille,len,fin,lookevent,flag;

  nb_child++;
  printf("\n* Reception d'une communication\n");

  printf("Open : ");
  newfh = t_open("/dev/nspx",O_RDWR,NULL);
  if(newfh == (-1))
     {
     t_error("Erreur");
     return;
     }
  printf("OK.\n");

  printf("Bind :");
  ccode=t_bind(newfh,NULL,NULL);
  if(ccode == -1)
     {
     t_error("Erreur");
     return;
     }
  printf("OK.\n");

  printf("Accept : ");
  if(t_accept(fh, newfh, &tcall) == -1)
     {
     t_error("Erreur");
     return;
     }
  printf("OK.\n");

  printf ("Allocation : ");
  buf=(char *)malloc(1000/*BUF_SIZE*/);
  if (buf==NULL)
     {
     printf("Plus de memoire \n");
     return;
     }
  printf("OK.\n");
  taille=BUF_SIZE;

  fin=1;
  while (fin==1)
     {
     ThreadSwitch();
     lookevent=t_look(newfh);
     switch (lookevent)
	      {
	      case T_DISCONNECT:
		 printf ("\n\n%d Disconnect", newfh);
		 t_rcvdis(newfh,NULL);
		 fin=0;
		 break;
	      case T_DATA:
		 len = t_rcv(newfh, buf,1000,&flag);
		 if (len !=-1)
		    magic(newfh,buf,len);
		 else
		 {
			t_error ("Erreur");
			fin=0;
		 }
	   break;
	      }
     if (finNLM==1)
	{
	printf ("toto\n");
	ccode=t_snddis(newfh,&tcall);
	if (ccode == -1)
	   {
	   t_error("Erreur");
	   }
	else
	   fin=0;
	}
     }

  free(buf);
  /* Disconnect */
  t_unbind (newfh);
  t_close (newfh);

  nb_child--;

  return;
  }

/***********************/
/** Program principal **/
/***********************/
void CoreProc(void)
  {
  int lookevent;

  for (;;)
     {
     ThreadSwitch();

     lookevent=t_look(fh);
     switch (lookevent)
	{
	case T_LISTEN:
	   if( t_listen(fh, &tcall) == -1 )
		    {
		    t_error("t_listen");
		    return;
	      }

	   printf("Demarage du fils : ");
	   ccode=BeginThread(ChildProcess, NULL, NULL, NULL);
	   if(ccode == (-1))
		    {
		    printf("ERROR: Failed.\n");
		    return;
		    }
	   else
		    printf("OK.\n");
	   break;
	}

     delay (1);
	   ThreadSwitch();
     }
  }

/**********************************/
/** Initialization du Programme. **/
/**********************************/
void Init()
  {
  printf("<<  INITIALISATION DU NLM TLI    >>\n");
  printf("<<                               >>\n");
  printf("<<  par BRETIN, COUERY, GUILHEM  >>\n");
  printf("<<  Mars 1996 Projet NOVELL      >>\n\n");


  /**** Verification de la procedure d'arret **/
  printf("- Verification du atexit: ");
  if(atexit(TerminateNLM) != NULL)
     {
     printf("ERROR: echec atexit().\n");
     exit(1);
     }
  else
     printf ("OK.\n");

  /**** Ouverture de la socket TLI **/
  printf("- Ouvertur Du TLI       : ");
  fh=t_open( "/dev/nspx", O_RDWR,NULL);
  if(fh == -1)
     {
     t_error("Erreur: ");
     exit(1);
     }
  printf("OK.\n");

  /** Initialisation des fonction TLI **/
  printf("- Initialisation Bind   : ");
  spx_addr.ipxa_socket[ 0 ]  = TLI_PORT>>8;
  spx_addr.ipxa_socket[ 1 ]  = TLI_PORT & 0xff;
  tbind.addr.len                        = sizeof( spx_addr );
  tbind.addr.maxlen             = sizeof( spx_addr );
  tbind.addr.buf                        = ( char * ) &spx_addr;
  tbind.qlen                            = 5;

  ccode=t_bind( fh, &tbind, &tbind );
  if(ccode == -1)
     {
     t_error("Erreur:");
     exit(1);
     }
  printf("OK.\n");

  /** Affectation des strucutres **/

  tcall.addr.buf                = ( char * ) &spx_addr;
  tcall.addr.maxlen     = sizeof( spx_addr );
  tcall.addr.len                = sizeof( spx_addr );
  spx_options.spx_connectionID[ 0 ]     = 0;
  spx_options.spx_connectionID[ 1 ]     = 0;
  spx_options.spx_allocationNumber[ 0 ] = 0;
  spx_options.spx_allocationNumber[ 1 ] = 0;
  tcall.opt.buf         = ( char * )&spx_options;
  tcall.opt.len         = sizeof( spx_options );
  tcall.opt.maxlen      = sizeof( spx_options );
  tcall.udata.buf               = ( char * )0;
  tcall.udata.maxlen    = 0;
  tcall.udata.len               = 0;
	}

/** MAIN () **/
void main()
   {
   Init();
   CoreProc();
   }
