
{*******************************************************}
{                                                       }
{   Types et structures                                 }
{   du Novell 4.0 Pour Borland DELPHI                   }
{                                                       }
{   Convertion du C au PASCAL                           }
{   par Couery Tanguy le 26/11/95                       }
{                                                       }
{   Pour le projet Novell Netware de 3me anne         }
{   (BRETIN David,COUERY Tanguy,GUILHEM Eric)           }
{                                                       }
{                                                       }
{*******************************************************}

unit TNet;

interface

type
  PInteger  = ^Integer;
  PByte     = ^Byte;
  PWord     = ^Word;
  PLongInt  = ^LongInt;
  Ppointer  = ^pointer;


type
PSYNTAX = ^SYNTAX;
SYNTAX = (
SYN_UNKNOWN,
SYN_DIST_NAME,
SYN_CE_STRING,
SYN_CI_STRING,
SYN_PR_STRING,
SYN_NU_STRING,
SYN_CI_LIST,
SYN_BOOLEAN,
SYN_INTEGER,
SYN_OCTET_STRING,
SYN_TEL_NUMBER,
SYN_FAX_NUMBER,
SYN_NET_ADDRESS,
SYN_OCTET_LIST,
SYN_EMAIL_ADDRESS,
SYN_PATH,
SYN_REPLICA_POINTER,
SYN_OBJECT_ACL,
SYN_PO_ADDRESS,
SYN_TIMESTAMP,
SYN_CLASS_NAME,
SYN_STREAM,
SYN_COUNTER,
SYN_BACK_LINK,
SYN_TIME,
SYN_TYPED_NAME,
SYN_HOLD,
SYN_INTERVAL,
SYNTAX_COUNT
);

type
PNAME_SPACE_TYPE = ^NAME_SPACE_TYPE;
NAME_SPACE_TYPE = (
DS_DOS,
DS_MACINTOSH,
DS_UNIX,
DS_FTAM,
DS_OS2
);

type
PREPLICA_TYPE = ^REPLICA_TYPE;
REPLICA_TYPE = (
RT_MASTER,
RT_SECONDARY,
RT_READONLY,
RT_SUBREF,
RT_COUNT
);

type
PREPLICA_STATE = ^REPLICA_STATE;
REPLICA_STATE = (
RS_ON,
RS_NEW_REPLICA,
RS_DYING_REPLICA,
RS_LOCKED,
RS_CRT_0,
RS_CRT_1,
RS_TRANSITION_ON,
RS_TRANSITION_MOVE,
RS_TRANSITION_SPLIT,
{RS_SS_0 = 48,}
RS_SS_1,
{RS_JS_0 = 64,}
RS_JS_1,
RS_JS_2,
{RS_MS_0 = 80,}
RS_MS_1,
RS_MS_2,
RS_COUNT
);

type
PNET_ADDRESS_TYPE = ^NET_ADDRESS_TYPE;
NET_ADDRESS_TYPE = (
NT_IPX,
NT_IP,
NT_SDLC,
NT_TOKENRING_ETHERNET,
NT_OSI,
NT_APPLETALK,
NT_COUNT
);

type
PNCP_SERVER_STATUS = ^NCP_SERVER_STATUS;
NCP_SERVER_STATUS = (
DS_UNKNOWN,
DS_DOWN,
DS_UP
);

type
PEMAIL_ADDRESS_TYPE = ^EMAIL_ADDRESS_TYPE;
EMAIL_ADDRESS_TYPE = (
{SMF70 = 1,}
SMF71,
SMTP,
X400,
SNADS,
PROFS
);

type
Psize_t = ^size_t;
size_t = word;

type
Punicode = ^unicode;
unicode = word;

type
PNWDSContextHandle = ^NWDSContextHandle;
NWDSContextHandle = longint;

type
PCE_String_T = ^CE_String_T;
CE_String_T = Pchar;

type
PClass_Name_T = ^Class_Name_T;
Class_Name_T = Pchar;

type
PCI_String_T = ^CI_String_T;
CI_String_T = Pchar;

type
PCN_String_T = ^CN_String_T;
CN_String_T = Pchar;

type
PDN_T = ^DN_T;
DN_T = Pchar;

type
PInteger_T = ^Integer_T;
Integer_T = longint;

type
PBoolean_T = ^Boolean_T;
Boolean_T = byte;

type
PNU_String_T = ^NU_String_T;
NU_String_T = Pchar;

type
PPostal_Address_T = ^Postal_Address_T;
Postal_Address_T = array[0..5] of Pchar;

type
PPR_String_T = ^PR_String_T;
PR_String_T = Pchar;

type
PSecure_Name_T = ^Secure_Name_T;
Secure_Name_T = Pchar;

type
PTN_String_T = ^TN_String_T;
TN_String_T = Pchar;

type
PCounter_T = ^Counter_T;
Counter_T = longint;

type
PBack_Link_T = ^Back_Link_T;
Back_Link_T = record
   remoteID: longint;
   objectName: Pchar;
end;

type
PBit_String_T = ^Bit_String_T;
Bit_String_T = record
   numOfBits: longint;
   data: Pbyte;
end;

type
PCI_List_T = ^CI_List_T;
CI_List_T = record
   next: PCI_List_T;
   s: Pchar;
end;

type
PFax_Number_T = ^Fax_Number_T;
Fax_Number_T = record
   telephoneNumber: Pchar;
   parameters: Bit_String_T;
end;

type
PTyped_Name_T = ^Typed_Name_T;
Typed_Name_T = record
   objectName: Pchar;
   level: longint;
   interval: longint;
end;

type
PNet_Address_T = ^Net_Address_T;
Net_Address_T = record
   addressType: longint;
   addressLength: longint;
   address: Pbyte;
end;

type
PObject_ACL_T = ^Object_ACL_T;
Object_ACL_T = record
   protectedAttrName: Pchar;
   subjectName: Pchar;
   privileges: longint;
end;

type
POctet_String_T = ^Octet_String_T;
Octet_String_T = record
   length: longint;
   data: Pbyte;
end;

type
PStream_T = ^Stream_T;
Stream_T = Octet_String_T;

type
POctet_List_T = ^Octet_List_T;
Octet_List_T = record
   next: POctet_List_T;
   length: longint;
   data: Pbyte;
end;

type
PHold_T = ^Hold_T;
Hold_T = record
   objectName: Pchar;
   amount: longint;
end;

type
PReplica_Pointer_T = ^Replica_Pointer_T;
Replica_Pointer_T = record
   serverName: Pchar;
   replicaType: longint;
   replicaNumber: longint;
   count: longint;
   replicaAddressHint: array [0..0] of Net_Address_T;
end;

type
PEMail_Address_T = ^EMail_Address_T;
EMail_Address_T = record
   _type: longint;
   address: Pchar;
end;

type
PPath_T = ^Path_T;
Path_T = record
   nameSpaceType: longint;
   volumeName: Pchar;
   path: Pchar;
end;

type
PNWDS_TimeStamp_T = ^NWDS_TimeStamp_T;
NWDS_TimeStamp_T = record
   wholeSeconds: longint;
   eventID: longint;
end;

type
PTimeStamp_T = ^TimeStamp_T;
TimeStamp_T = record
   wholeSeconds: longint;
   replicaNum: word;
   eventID: word;
end;

type
PUnknown_Attr_T = ^Unknown_Attr_T;
Unknown_Attr_T = record
   attrName: Pchar;
   syntaxID: longint;
   valueLen: longint;
   value: pointer;
end;

type
PBuf_T = ^Buf_T;
Buf_T = record
   operation: longint;
   flags: longint;
   maxLen: longint;
   curLen: longint;
   lastCount: Pbyte;
   curPos: Pbyte;
   data: Pbyte;
end;

type
PObject_Info_T = ^Object_Info_T;
Object_Info_T = record
   objectFlags: longint;
   subordinateCount: longint;
{   modificationTime: time_t;}
   baseClass: array [0..63] of char;
end;

type
PAsn1ID_T = ^Asn1ID_T;
Asn1ID_T = record
   length: longint;
   data: array [0..31] of byte;
end;

type
PAttr_Info_T = ^Attr_Info_T;
Attr_Info_T = record
   attrFlags: longint;
   attrSyntaxID: longint;
   attrLower: longint;
   attrUpper: longint;
   asn1ID: Asn1ID_T;
end;

type
PClass_Info_T = ^Class_Info_T;
Class_Info_T = record
   classFlags: longint;
   asn1ID: Asn1ID_T;
end;

type
PSyntax_Info_T = ^Syntax_Info_T;
Syntax_Info_T = record
   ID: longint;
   defStr: array [0..63] of char;
   flags: shortint;
end;

type
PFilter_Node_T = ^Filter_Node_T;
Filter_Node_T = record
   parent: PFilter_Node_T;
   left: PFilter_Node_T;
   right: PFilter_Node_T;
   value: pointer;
   syntax: longint;
   token: word;
end;

type
PFilter_Cursor_T = ^Filter_Cursor_T;
Filter_Cursor_T = record
   fn: PFilter_Node_T;
   level: word;
   expect: longint;
end;

type
PCONNECT_INFO = ^CONNECT_INFO;
CONNECT_INFO = record
   connID: word;
   connectFlags: word;
   sessionID: word;
   connNumber: word;
   serverAddr: array [0..11] of byte;
   serverType: word;
   serverName: array [0..47] of char;
   clientType: word;
   clientName: array [0..47] of char;
end;

type
PCONN_USE = ^CONN_USE;
CONN_USE = record
   systemElapsedTime: longint;
   bytesRead: array [0..5] of byte;
   bytesWritten: array [0..5] of byte;
   totalRequestPackets: longint;
end;

type
PNWINET_ADDR = ^NWINET_ADDR;
NWINET_ADDR = record
   networkAddr: array [0..3] of byte;
   netNodeAddr: array [0..5] of byte;
   socket: word;
   connType: word;
end;

type
PNWDS_Session_Key_T = ^NWDS_Session_Key_T;
NWDS_Session_Key_T = array[0..15] of byte;

type
PNWEventBitMap = ^NWEventBitMap;
NWEventBitMap = record
   bitMap: array [0..63] of byte;
end;

type
PauditBitMapIDs = ^auditBitMapIDs;
auditBitMapIDs = (
{ADS_BIT_ADD_ENTRY = 1,
ADS_BIT_REMOVE_ENTRY = 2,
ADS_BIT_RENAME_OBJECT = 3,
ADS_BIT_MOVE_ENTRY = 4,
ADS_BIT_ADD_SECURITY_EQUIV = 5,
ADS_BIT_REMOVE_SECURITY_EQUIV = 6,
ADS_BIT_ADD_ACL = 7,
ADS_BIT_REMOVE_ACL = 8,
A_BIT_BIND_CHG_OBJ_SECURITY = 32,}
A_BIT_BIND_CHG_PROP_SECURITY,
A_BIT_BIND_CREATE_OBJ,
A_BIT_BIND_CREATE_PROPERTY,
A_BIT_BIND_DELETE_OBJ,
A_BIT_BIND_DELETE_PROPERTY,
A_BIT_CHANGE_DATE_TIME,
A_BIT_CHANGE_EQUIVALENCE,
A_BIT_CHANGE_SECURITY_GROUP,
A_BIT_UCLOSE_FILE,
A_BIT_CLOSE_BINDERY,
A_BIT_UCREATE_FILE,
A_BIT_CREATE_USER,
A_BIT_UDELETE_FILE,
A_BIT_DELETE_USER,
A_BIT_DIR_SPACE_RESTRICTIONS,
A_BIT_DISABLE_ACCOUNT,
A_BIT_DOWN_SERVER,
A_BIT_GRANT_TRUSTEE,
A_BIT_INTRUDER_LOCKOUT_CHANGE,
A_BIT_LOGIN_USER,
A_BIT_LOGIN_USER_FAILURE,
A_BIT_LOGOUT_USER,
A_BIT_NET_LOGIN,
A_BIT_UMODIFY_ENTRY,
A_BIT_OPEN_BINDERY,
A_BIT_UOPEN_FILE,
A_BIT_UREAD_FILE,
A_BIT_REMOVE_TRUSTEE,
A_BIT_URENAME_MOVE_FILE,
A_BIT_RENAME_USER,
A_BIT_USALVAGE_FILE,
A_BIT_STATION_RESTRICTIONS,
A_BIT_CHANGE_PASSWORD,
A_BIT_TERMINATE_CONNECTION,
A_BIT_UP_SERVER,
A_BIT_USER_CHANGE_PASSWORD,
A_BIT_USER_LOCKED,
A_BIT_USER_SPACE_RESTRICTIONS,
A_BIT_USER_UNLOCKED,
A_BIT_VOLUME_MOUNT,
A_BIT_VOLUME_DISMOUNT,
A_BIT_UWRITE_FILE,
A_BIT_GOPEN_FILE,
A_BIT_GCLOSE_FILE,
A_BIT_GCREATE_FILE,
A_BIT_GDELETE_FILE,
A_BIT_GREAD_FILE,
A_BIT_GWRITE_FILE,
A_BIT_GRENAME_MOVE_FILE,
A_BIT_GMODIFY_ENTRY,
A_BIT_IOPEN_FILE,
A_BIT_ICLOSE_FILE,
A_BIT_ICREATE_FILE,
A_BIT_IDELETE_FILE,
A_BIT_IREAD_FILE,
A_BIT_IWRITE_FILE,
A_BIT_IRENAME_MOVE_FILE,
A_BIT_IMODIFY_ENTRY,
A_BIT_Q_ATTACH_SERVER,
A_BIT_Q_CREATE,
A_BIT_Q_CREATE_JOB,
A_BIT_Q_DESTROY,
A_BIT_Q_DETACH_SERVER,
A_BIT_Q_EDIT_JOB,
A_BIT_Q_JOB_FINISH,
A_BIT_Q_JOB_SERVICE,
A_BIT_Q_JOB_SERVICE_ABORT,
A_BIT_Q_REMOVE_JOB,
A_BIT_Q_SET_JOB_PRIORITY,
A_BIT_Q_SET_STATUS,
A_BIT_Q_START_JOB,
A_BIT_Q_SWAP_RIGHTS,
A_BIT_NLM_ADD_RECORD,
A_BIT_NLM_ADD_ID_RECORD,
A_BIT_CLOSE_MODIFIED_FILE,
A_BIT_GCREATE_DIRECTORY,
A_BIT_ICREATE_DIRECTORY,
A_BIT_UCREATE_DIRECTORY,
A_BIT_GDELETE_DIRECTORY,
A_BIT_IDELETE_DIRECTORY,
A_BIT_UDELETE_DIRECTORY
);

type
PNWVolumeAuditStatus = ^NWVolumeAuditStatus;
NWVolumeAuditStatus = record
   auditingVersionDate: word;
   auditFileVersionDate: word;
   auditingEnabledFlag: longint;
   volumeAuditFileSize: longint;
   volumeAuditConfigFileSize: longint;
   volumeAuditFileMaxSize: longint;
   volumeAuditFileSizeThreshold: longint;
   auditRecordCount: longint;
   historyRecordCount: longint;
end;

type
PNWContainerAuditStatus = ^NWContainerAuditStatus;
NWContainerAuditStatus = record
   auditingVersionDate: word;
   auditFileVersionDate: word;
   auditingEnabledFlag: longint;
   containerAuditFileSize: longint;
   containerAuditConfigFileSize: longint;
   containerAuditFileMaxSize: longint;
   containerAuditFileSizeThreshold: longint;
   auditRecordCount: longint;
   historyRecordCount: longint;
end;

type
PTIMESTAMP = ^TIMESTAMP;
TIMESTAMP = record
   seconds: longint;
   replicaNumber: word;
   event: word;
end;

type
PNWConfigHeader = ^NWConfigHeader;
NWConfigHeader = record
   fileVersionDate: word;
   auditFlags: byte;
   errMsgDelayMinutes: byte;
   reserved: array [0..15] of byte;
   volumeAuditFileMaxSize: longint;
   volumeAuditFileSizeThreshold: longint;
   auditRecordCount: longint;
   historyRecordCount: longint;
   spareLongs: array [0..6] of longint;
   volumeAuditEventBitMap: NWEventBitMap;
end;

type
PNWDSContainerConfigHdr = ^NWDSContainerConfigHdr;
NWDSContainerConfigHdr = record
   fileVersionDate: word;
   auditFlags: byte;
   errMsgDelayMinutes: byte;
   containerID: longint;
   spareLong0: longint;
   creationTS: TIMESTAMP;
   bitMap: longint;
   auditFileMaxSize: longint;
   auditFileSizeThreshold: longint;
   auditRecordCount: longint;
   replicaNumber: word;
   enabledFlag: byte;
   spareBytes: array [0..2] of byte;
   numberReplicaEntries: word;
   spareLongs: array [0..8] of longint;
   auditDisabledCounter: longint;
   auditEnabledCounter: longint;
   reserved: array [0..31] of byte;
   hdrModifiedCounter: longint;
   fileResetCounter: longint;
end;

type
PauditRcd = ^auditRcd;
auditRcd = record
   eventTypeID: word;
   chkWord: word;
   connectionID: longint;
   processUniqueID: longint;
   successFailureStatusCode: longint;
   dosDate: word;
   dosTime: word;
end;

type
PauditDSRcd = ^auditDSRcd;
auditDSRcd = record
   replicaNumber: word;
   eventTypeID: word;
   recordNumber: longint;
   dosDateTime: longint;
   userID: longint;
   processUniqueID: longint;
   successFailureStatusCode: longint;
end;

type
PauditedEventIDs = ^auditedEventIDs;
auditedEventIDs = (
{A_EVENT_BIND_CHG_OBJ_SECURITY = 1,
A_EVENT_BIND_CHG_PROP_SECURITY = 2,
A_EVENT_BIND_CREATE_OBJ = 3,
A_EVENT_BIND_CREATE_PROPERTY = 4,
A_EVENT_BIND_DELETE_OBJ = 5,
A_EVENT_BIND_DELETE_PROPERTY = 6,
A_EVENT_CHANGE_DATE_TIME = 7,
A_EVENT_CHANGE_EQUIVALENCE = 8,
A_EVENT_CHANGE_SECURITY_GROUP = 9,
A_EVENT_CLOSE_FILE = 10,
A_EVENT_CLOSE_BINDERY = 11,
A_EVENT_CREATE_FILE = 12,
A_EVENT_CREATE_USER = 13,
A_EVENT_DELETE_FILE = 14,
A_EVENT_DELETE_USER = 15,
A_EVENT_DIR_SPACE_RESTRICTIONS = 16,
A_EVENT_DISABLE_ACCOUNT = 17,
A_EVENT_DOWN_SERVER = 18,
A_EVENT_GRANT_TRUSTEE = 19,
A_EVENT_INTRUDER_LOCKOUT_CHANGE = 20,
A_EVENT_LOGIN_USER = 21,
A_EVENT_LOGIN_USER_FAILURE = 22,
A_EVENT_LOGOUT_USER = 23,
A_EVENT_NET_LOGIN = 24,
A_EVENT_MODIFY_ENTRY = 25,
A_EVENT_OPEN_BINDERY = 26,
A_EVENT_OPEN_FILE = 27,
A_EVENT_Q_ATTACH_SERVER = 28,
A_EVENT_Q_CREATE = 29,
A_EVENT_Q_CREATE_JOB = 30,
A_EVENT_Q_DESTROY = 31,
A_EVENT_Q_DETACH_SERVER = 32,
A_EVENT_Q_EDIT_JOB = 33,
A_EVENT_Q_JOB_FINISH = 34,
A_EVENT_Q_JOB_SERVICE = 35,
A_EVENT_Q_JOB_SERVICE_ABORT = 36,
A_EVENT_Q_REMOVE_JOB = 37,
A_EVENT_Q_SET_JOB_PRIORITY = 38,
A_EVENT_Q_SET_STATUS = 39,
A_EVENT_Q_START_JOB = 40,
A_EVENT_Q_SWAP_RIGHTS = 41,
A_EVENT_READ_FILE = 42,
A_EVENT_REMOVE_TRUSTEE = 43,
A_EVENT_RENAME_MOVE_FILE = 44,
A_EVENT_RENAME_USER = 45,
A_EVENT_SALVAGE_FILE = 46,
A_EVENT_STATION_RESTRICTIONS = 47,
A_EVENT_CHANGE_PASSWORD = 48,
A_EVENT_TERMINATE_CONNECTION = 49,
A_EVENT_UP_SERVER = 50,
A_EVENT_USER_CHANGE_PASSWORD = 51,
A_EVENT_USER_LOCKED = 52,
A_EVENT_USER_SPACE_RESTRICTIONS = 53,
A_EVENT_USER_UNLOCKED = 54,
A_EVENT_VOLUME_MOUNT = 55,
A_EVENT_VOLUME_DISMOUNT = 56,
A_EVENT_WRITE_FILE = 57,
AUDITING_ACTIVE_CONNECTION_RCD = 58,
AUDITING_ADD_AUDITOR_ACCESS = 59,
AUDITING_ADD_AUDIT_PROPERTY = 60,
AUDITING_CHANGE_AUDIT_PASSWORD = 61,
AUDITING_DELETE_AUDIT_PROPERTY = 62,
AUDITING_DISABLE_VOLUME_AUDIT = 63,
AUDITING_OPEN_FILE_HANDLE_RCD = 64,
AUDITING_ENABLE_VOLUME_AUDITING = 65,
AUDITING_REMOVE_AUDITOR_ACCESS = 66,
AUDITING_RESET_AUDIT_FILE = 67,
AUDITING_RESET_AUDIT_FILE2 = 68,
AUDITING_RESET_CONFIG_FILE = 69,
AUDITING_WRITE_AUDIT_BIT_MAP = 70,
AUDITING_WRITE_AUDIT_CONFIG_HDR = 71,
AUDITING_NLM_ADD_RECORD = 72,
AUDITING_ADD_NLM_ID_RECORD = 73,
AUDITING_CHANGE_AUDIT_PASSWORD2 = 74,
A_EVENT_CREATE_DIRECTORY = 75,
A_EVENT_DELETE_DIRECTORY = 76,}
A_EVENT_LAST_PLUS_ONE
);

type
PauditedDSDEventIDs = ^auditedDSDEventIDs;
auditedDSDEventIDs = (
{AUDITING_DISABLE_CNT_AUDIT = 91,
AUDITING_ENABLE_CNT_AUDITING = 92,
AUDITING_RESET_HISTORY_FILE = 33,
ADS_ADD_ENTRY = 101,
ADS_REMOVE_ENTRY = 102,
ADS_RENAME_OBJECT = 103,
ADS_MOVE_ENTRY = 104,
ADS_ADD_SECURITY_EQUIVALENCE = 105,
ADS_REMOVE_SECURITY_EQUIVALENCE = 106,
ADS_ADD_ACL = 107,
ADS_REMOVE_ACL = 108,}
ADS_LAST_PLUS_ONE
);

type
PModifyStructure = ^ModifyStructure;
ModifyStructure = record
   MModifyName: Pbyte;
   MFileAttributes: longint;
   MFileAttributesMask: longint;
   MCreateDate: word;
   MCreateTime: word;
   MOwnerID: longint;
   MLastArchivedDate: word;
   MLastArchivedTime: word;
   MLastArchivedID: longint;
   MLastUpdatedDate: word;
   MLastUpdatedTime: word;
   MLastUpdatedID: longint;
   MLastAccessedDate: word;
   MInheritanceGrantMask: word;
   MInheritanceRevokeMask: word;
   MMaximumSpace: longint;
end;

type
PEventUnion = ^EventUnion;
EventUnion = record
case integer of
   0: (EChgDate: record
   newDosDateTime: longint;
end);
   1: (ECreateUser: record
   userID: longint;
   name: array [0..0] of byte;
end);
   2: (EBindChgSecurity: record
   newSecurity: longint;
   oldSecurity: longint;
   name: array [0..0] of byte;
end);
   3: (EBindChgSecGrp: record
   addFlag: longint;
   objName: array [0..0] of byte;
   name: array [0..0] of byte;
end);
   4: (EBindCreateObj: record
   objectID: longint;
   security: longint;
   name: array [0..0] of byte;
end);
   5: (EBindCreateProp: record
   security: longint;
   name: array [0..0] of byte;
end);
   6: (EBindDeleteProp: record
   name: array [0..0] of byte;
end);
   7: (EILockChg: record
   hbaa: byte;
   lbaa: byte;
   hbrm: byte;
   lbrm: byte;
   hblm: byte;
   lblm: byte;
end);
   8: (ELogin: record
   userID: longint;
   networkAddressType: byte;
   networkAddressLength: byte;
   networkAddress: array [0..0] of byte;
   name: array [0..0] of byte;
end);
   9: (EChgPasswd: record
   name: array [0..0] of byte;
end);
   10: (EChgSecurity: record
   newSecurity: longint;
   oldSecurity: longint;
   name: array [0..0] of byte;
end);
   11: (EFDelete: record
   nameSpace: longint;
   fileName: array [0..0] of byte;
end);
   12: (EFOpen: record
   handle: longint;
   rights: longint;
   nameSpace: longint;
   fileName: array [0..0] of byte;
end);
   13: (EFClose: record
   handle: longint;
   modified: longint;
end);
   14: (EFRead: record
   handle: longint;
   byteCount: longint;
   offset: longint;
end);
   15: (EAuditProperty: record
   name: array [0..0] of byte;
end);
   16: (EModify: record
   modifyBits: longint;
   nameSpace: longint;
   modifyStruct: array[0..(sizeof(ModifyStructure)-1)] of byte;
   fileName: array [0..0] of byte;
   oldDosName: array [0..0] of byte;
   newOwner: array [0..0] of byte;
   lastArchivedBy: array [0..0] of byte;
   lastModifiedBy: array [0..0] of byte;
end);
   17: (EQAttach: record
   qname: array [0..0] of byte;
end);
   18: (EQCreate: record
   qType: longint;
   fileName: array [0..0] of byte;
end);
   19: (EQJobService: record
   tType: longint;
   qname: array [0..0] of byte;
end);
   20: (EQSetStatus: record
   status: longint;
   qname: array [0..0] of byte;
end);
   21: (EStnRestrictions: record
   name: array [0..0] of byte;
   netAddress: array [0..0] of byte;
end);
   22: (ETrustee: record
   trusteeID: longint;
   rights: longint;
   nameSpace: longint;
   trusteeName: array [0..0] of byte;
   fileName: array [0..0] of byte;
end);
   23: (ETSpace: record
   spaceValue: longint;
   trusteeName: array [0..0] of byte;
end);
   24: (ENLMRecord: record
   recordTypeID: longint;
   dataLen: longint;
   userName: array [0..0] of byte;
   data: array [0..0] of byte;
end);
end;

implementation

end.
