unit TNWBind;

interface

uses Classes, NWConn;

type
    TNWBindery = class(TComponent)
    private
        { Private-dclarations }
        FNWConn: TNWConn;
        procedure FreeObjListe(Liste: TStrings);
    protected
        { Protected-dclarations }
    public
        { Public-dclarations }
        constructor Create(AOwner: TComponent); override;
        function CreerObject(ObjNom: string; ObjType: Word; ObjFlags: Byte; ObjSecurite: Byte): Word;
        procedure ChercheObjects(Liste: TStrings; AliasNom: String; AliasType: Word);
        procedure ChercheObjectsSB(Liste: TStrings; AliasNom: string; AliasType: word);
    published
        { Published-dclarations }
        property NwConn: TNWConn read FNWConn write FNWConn;
    end;


procedure Register;

implementation

uses Dialogs, SysUtils,
        NWCalls, NWConst,NWConst2,
        TNWObj, TNWGroup, TNWUti, TNWSvrPr, TNWSvrFi, TNWFilPr, TNWProf, SB_Const, NLMUti;

{********************************** P U B L I C **************************************************}
constructor TNWBindery.Create(AOwner: TComponent);
var Ret: Word;
begin
    inherited Create(AOwner);
    Ret := NWCallsInit(NIL,NIL);
    if (Ret <> 0) then
    begin
        MessageDlg('Erreur du NWCallsInit', mtError, [mbOK], 0);
        Halt;
    end;
end;


function TNWBindery.CreerObject(ObjNom: string; ObjType: Word; ObjFlags: Byte; ObjSecurite: Byte): Word;
var PObjNom: Pchar;
begin
    GetMem(PObjNom, 48);
    StrPCopy(PObjNom, ObjNom);
    Result := CreateObject(FNWConn.Handle, PObjNom, ObjType, ObjFlags, ObjSecurite);
    FreeMem(PObjNom, 48);
end;


procedure TNWBindery.ChercheObjectsSB(Liste: TStrings; AliasNom: string; AliasType: word);
var Temp: TStringList;
begin
    if (AliasType = SB_TOUS) then
        ChercheObjects(Liste, AliasNom, OT_WILD)
    else
    begin
        FreeObjListe(Liste);
        Liste.Clear;
        if ((AliasType and SB_UTILISATEUR) <> 0) then
        begin
            Temp := TStringList.Create;
            ChercheObjects(Temp, AliasNom, OT_USER);
            Liste.AddStrings(Temp);
            Temp.Free;
        end;
        if ((AliasType and SB_GROUPE) <> 0) then
        begin
            Temp := TStringList.Create;
            ChercheObjects(Temp, AliasNom, OT_USER_GROUP);
            Liste.AddStrings(Temp);
            Temp.Free;
        end;
        if ((AliasType and SB_SERVEUR_FICHIER) <> 0) then
        begin
            Temp := TStringList.Create;
            ChercheObjects(Temp, AliasNom, OT_FILE_SERVER);
            Liste.AddStrings(Temp);
            Temp.Free;
        end;
        if ((AliasType and SB_SERVEUR_IMPRIMANTE) <> 0) then
        begin
            Temp := TStringList.Create;
            ChercheObjects(Temp, AliasNom, OT_PRINT_SERVER);
            Liste.AddStrings(Temp);
            Temp.Free;
        end;
        if ((AliasType and SB_FILE_IMPRIMANTE) <> 0) then
        begin
            Temp := TStringList.Create;
            ChercheObjects(Temp, AliasNom, OT_PRINT_QUEUE);
            Liste.AddStrings(Temp);
            Temp.Free;
        end;
        if ((AliasType and SB_PROFILE) <> 0) then
        begin
            Temp := TStringList.Create;
            ChercheObjects(Temp, AliasNom, $3501);
            Liste.AddStrings(Temp);
            Temp.Free;
        end;
    end;
end;


procedure TNWBindery.ChercheObjects(Liste: TStrings; AliasNom: string; AliasType: word);
var Ret: Word;
    PCharAliasNom: PChar;
    ObjID: LongInt;
    ObjName: PChar;
    ObjType: Word;
    ObjHasPptes: Byte;
    ObjFlag: Byte;
    ObjSecu: Byte;
    NouveauObject: TNWObject;
begin
    FreeObjListe(Liste);
    Liste.Clear;
    GetMem(PCharAliasNom, length(AliasNom));
    StrPCopy(PCharAliasNom, AliasNom);
    GetMem(ObjName, 48);
    ObjID := -1;
    while (ScanObject(FNWConn.Handle, PCharAliasNom, AliasType, @ObjID, ObjName,
            @ObjType, @ObjHasPptes, @ObjFlag, @ObjSecu) = 0) do
    begin
        case ObjType of
            OT_USER: NouveauObject := TNWUtilisateur.Create(Self, ObjID,StrPas(ObjName),
                                        ObjType, ObjHasPptes, ObjFlag, ObjSecu);
            OT_USER_GROUP: NouveauObject := TNWGroupe.Create(Self, ObjID,StrPas(ObjName),
                                        ObjType, ObjHasPptes, ObjFlag, ObjSecu);
            OT_PRINT_SERVER: NouveauObject := TNWServeurImprimante.Create(Self, ObjID,StrPas(ObjName),
                                        ObjType, ObjHasPptes, ObjFlag, ObjSecu);
            OT_FILE_SERVER:  NouveauObject := TNWServeurFichier.Create(Self, ObjID,StrPas(ObjName),
                                        ObjType, ObjHasPptes, ObjFlag, ObjSecu);
            OT_PRINT_QUEUE: NouveauObject := TNWFileImpression.Create(Self, ObjID,StrPas(ObjName),
                                        ObjType, ObjHasPptes, ObjFlag, ObjSecu);
            $3501: NouveauObject := TNWProfile.Create(Self, ObjID,StrPas(ObjName),
                                        ObjType, ObjHasPptes, ObjFlag, ObjSecu);
            else NouveauObject := TNWObject.Create(Self, ObjID, StrPas(ObjName),
                                        ObjType, ObjHasPptes, ObjFlag, ObjSecu);
        end;
        Liste.AddObject(StrPas(ObjName), NouveauObject);
    end;
    FreeMem(ObjName, 48);
    FreeMem(PCharAliasNom, length(AliasNom));
end;

{************************************* P R I V A T E *********************************************}
procedure TNWBindery.FreeObjListe(Liste: TStrings);
var Compteur: Integer;
begin
    for Compteur := 0 to Liste.Count-1 do Liste.Objects[Compteur].Free;
end;

procedure Register;
begin
  RegisterComponents('Exemples', [TNWBindery]);
end;

end.
